git-rebase.shon commit t7415: don't bother creating commit for symlink test (431acd2)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6SUBDIRECTORY_OK=Yes
   7OPTIONS_KEEPDASHDASH=
   8OPTIONS_STUCKLONG=t
   9OPTIONS_SPEC="\
  10git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] [<upstream>] [<branch>]
  11git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] --root [<branch>]
  12git rebase --continue | --abort | --skip | --edit-todo
  13--
  14 Available options are
  15v,verbose!         display a diffstat of what changed upstream
  16q,quiet!           be quiet. implies --no-stat
  17autostash          automatically stash/stash pop before and after
  18fork-point         use 'merge-base --fork-point' to refine upstream
  19onto=!             rebase onto given branch instead of upstream
  20p,preserve-merges! try to recreate merges instead of ignoring them
  21s,strategy=!       use the given merge strategy
  22no-ff!             cherry-pick all commits, even if unchanged
  23m,merge!           use merging strategies to rebase
  24i,interactive!     let the user edit the list of commits to rebase
  25x,exec=!           add exec lines after each commit of the editable list
  26k,keep-empty       preserve empty commits during rebase
  27allow-empty-message allow rebasing commits with empty messages
  28f,force-rebase!    force rebase even if branch is up to date
  29X,strategy-option=! pass the argument through to the merge strategy
  30stat!              display a diffstat of what changed upstream
  31n,no-stat!         do not show diffstat of what changed upstream
  32verify             allow pre-rebase hook to run
  33rerere-autoupdate  allow rerere to update index with resolved conflicts
  34root!              rebase all reachable commits up to the root(s)
  35autosquash         move commits that begin with squash!/fixup! under -i
  36committer-date-is-author-date! passed to 'git am'
  37ignore-date!       passed to 'git am'
  38signoff            passed to 'git am'
  39whitespace=!       passed to 'git apply'
  40ignore-whitespace! passed to 'git apply'
  41C=!                passed to 'git apply'
  42S,gpg-sign?        GPG-sign commits
  43 Actions:
  44continue!          continue
  45abort!             abort and check out the original branch
  46skip!              skip current patch and continue
  47edit-todo!         edit the todo list during an interactive rebase
  48quit!              abort but keep HEAD where it is
  49show-current-patch! show the patch file being applied or merged
  50"
  51. git-sh-setup
  52set_reflog_action rebase
  53require_work_tree_exists
  54cd_to_toplevel
  55
  56LF='
  57'
  58ok_to_skip_pre_rebase=
  59resolvemsg="
  60$(gettext 'Resolve all conflicts manually, mark them as resolved with
  61"git add/rm <conflicted_files>", then run "git rebase --continue".
  62You can instead skip this commit: run "git rebase --skip".
  63To abort and get back to the state before "git rebase", run "git rebase --abort".')
  64"
  65unset onto
  66unset restrict_revision
  67cmd=
  68strategy=
  69strategy_opts=
  70do_merge=
  71merge_dir="$GIT_DIR"/rebase-merge
  72apply_dir="$GIT_DIR"/rebase-apply
  73verbose=
  74diffstat=
  75test "$(git config --bool rebase.stat)" = true && diffstat=t
  76autostash="$(git config --bool rebase.autostash || echo false)"
  77fork_point=auto
  78git_am_opt=
  79git_format_patch_opt=
  80rebase_root=
  81force_rebase=
  82allow_rerere_autoupdate=
  83# Non-empty if a rebase was in progress when 'git rebase' was invoked
  84in_progress=
  85# One of {am, merge, interactive}
  86type=
  87# One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
  88state_dir=
  89# One of {'', continue, skip, abort}, as parsed from command line
  90action=
  91preserve_merges=
  92autosquash=
  93keep_empty=
  94allow_empty_message=
  95test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
  96case "$(git config --bool commit.gpgsign)" in
  97true)   gpg_sign_opt=-S ;;
  98*)      gpg_sign_opt= ;;
  99esac
 100
 101read_basic_state () {
 102        test -f "$state_dir/head-name" &&
 103        test -f "$state_dir/onto" &&
 104        head_name=$(cat "$state_dir"/head-name) &&
 105        onto=$(cat "$state_dir"/onto) &&
 106        # We always write to orig-head, but interactive rebase used to write to
 107        # head. Fall back to reading from head to cover for the case that the
 108        # user upgraded git with an ongoing interactive rebase.
 109        if test -f "$state_dir"/orig-head
 110        then
 111                orig_head=$(cat "$state_dir"/orig-head)
 112        else
 113                orig_head=$(cat "$state_dir"/head)
 114        fi &&
 115        GIT_QUIET=$(cat "$state_dir"/quiet) &&
 116        test -f "$state_dir"/verbose && verbose=t
 117        test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
 118        test -f "$state_dir"/strategy_opts &&
 119                strategy_opts="$(cat "$state_dir"/strategy_opts)"
 120        test -f "$state_dir"/allow_rerere_autoupdate &&
 121                allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
 122        test -f "$state_dir"/gpg_sign_opt &&
 123                gpg_sign_opt="$(cat "$state_dir"/gpg_sign_opt)"
 124}
 125
 126write_basic_state () {
 127        echo "$head_name" > "$state_dir"/head-name &&
 128        echo "$onto" > "$state_dir"/onto &&
 129        echo "$orig_head" > "$state_dir"/orig-head &&
 130        echo "$GIT_QUIET" > "$state_dir"/quiet &&
 131        test t = "$verbose" && : > "$state_dir"/verbose
 132        test -n "$strategy" && echo "$strategy" > "$state_dir"/strategy
 133        test -n "$strategy_opts" && echo "$strategy_opts" > \
 134                "$state_dir"/strategy_opts
 135        test -n "$allow_rerere_autoupdate" && echo "$allow_rerere_autoupdate" > \
 136                "$state_dir"/allow_rerere_autoupdate
 137        test -n "$gpg_sign_opt" && echo "$gpg_sign_opt" > "$state_dir"/gpg_sign_opt
 138}
 139
 140output () {
 141        case "$verbose" in
 142        '')
 143                output=$("$@" 2>&1 )
 144                status=$?
 145                test $status != 0 && printf "%s\n" "$output"
 146                return $status
 147                ;;
 148        *)
 149                "$@"
 150                ;;
 151        esac
 152}
 153
 154move_to_original_branch () {
 155        case "$head_name" in
 156        refs/*)
 157                message="rebase finished: $head_name onto $onto"
 158                git update-ref -m "$message" \
 159                        $head_name $(git rev-parse HEAD) $orig_head &&
 160                git symbolic-ref \
 161                        -m "rebase finished: returning to $head_name" \
 162                        HEAD $head_name ||
 163                die "$(eval_gettext "Could not move back to \$head_name")"
 164                ;;
 165        esac
 166}
 167
 168apply_autostash () {
 169        if test -f "$state_dir/autostash"
 170        then
 171                stash_sha1=$(cat "$state_dir/autostash")
 172                if git stash apply $stash_sha1 >/dev/null 2>&1
 173                then
 174                        echo "$(gettext 'Applied autostash.')" >&2
 175                else
 176                        git stash store -m "autostash" -q $stash_sha1 ||
 177                        die "$(eval_gettext "Cannot store \$stash_sha1")"
 178                        gettext 'Applying autostash resulted in conflicts.
 179Your changes are safe in the stash.
 180You can run "git stash pop" or "git stash drop" at any time.
 181' >&2
 182                fi
 183        fi
 184}
 185
 186finish_rebase () {
 187        rm -f "$(git rev-parse --git-path REBASE_HEAD)"
 188        apply_autostash &&
 189        { git gc --auto || true; } &&
 190        rm -rf "$state_dir"
 191}
 192
 193run_specific_rebase () {
 194        if [ "$interactive_rebase" = implied ]; then
 195                GIT_EDITOR=:
 196                export GIT_EDITOR
 197                autosquash=
 198        fi
 199        . git-rebase--$type
 200        ret=$?
 201        if test $ret -eq 0
 202        then
 203                finish_rebase
 204        elif test $ret -eq 2 # special exit status for rebase -i
 205        then
 206                apply_autostash &&
 207                rm -rf "$state_dir" &&
 208                die "Nothing to do"
 209        fi
 210        exit $ret
 211}
 212
 213run_pre_rebase_hook () {
 214        if test -z "$ok_to_skip_pre_rebase" &&
 215           test -x "$(git rev-parse --git-path hooks/pre-rebase)"
 216        then
 217                "$(git rev-parse --git-path hooks/pre-rebase)" ${1+"$@"} ||
 218                die "$(gettext "The pre-rebase hook refused to rebase.")"
 219        fi
 220}
 221
 222test -f "$apply_dir"/applying &&
 223        die "$(gettext "It looks like 'git am' is in progress. Cannot rebase.")"
 224
 225if test -d "$apply_dir"
 226then
 227        type=am
 228        state_dir="$apply_dir"
 229elif test -d "$merge_dir"
 230then
 231        if test -f "$merge_dir"/interactive
 232        then
 233                type=interactive
 234                interactive_rebase=explicit
 235        else
 236                type=merge
 237        fi
 238        state_dir="$merge_dir"
 239fi
 240test -n "$type" && in_progress=t
 241
 242total_argc=$#
 243while test $# != 0
 244do
 245        case "$1" in
 246        --no-verify)
 247                ok_to_skip_pre_rebase=yes
 248                ;;
 249        --verify)
 250                ok_to_skip_pre_rebase=
 251                ;;
 252        --continue|--skip|--abort|--quit|--edit-todo|--show-current-patch)
 253                test $total_argc -eq 2 || usage
 254                action=${1##--}
 255                ;;
 256        --onto=*)
 257                onto="${1#--onto=}"
 258                ;;
 259        --exec=*)
 260                cmd="${cmd}exec ${1#--exec=}${LF}"
 261                test -z "$interactive_rebase" && interactive_rebase=implied
 262                ;;
 263        --interactive)
 264                interactive_rebase=explicit
 265                ;;
 266        --keep-empty)
 267                keep_empty=yes
 268                ;;
 269        --allow-empty-message)
 270                allow_empty_message=--allow-empty-message
 271                ;;
 272        --preserve-merges)
 273                preserve_merges=t
 274                test -z "$interactive_rebase" && interactive_rebase=implied
 275                ;;
 276        --autosquash)
 277                autosquash=t
 278                ;;
 279        --no-autosquash)
 280                autosquash=
 281                ;;
 282        --fork-point)
 283                fork_point=t
 284                ;;
 285        --no-fork-point)
 286                fork_point=
 287                ;;
 288        --merge)
 289                do_merge=t
 290                ;;
 291        --strategy-option=*)
 292                strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--${1#--strategy-option=}")"
 293                do_merge=t
 294                test -z "$strategy" && strategy=recursive
 295                ;;
 296        --strategy=*)
 297                strategy="${1#--strategy=}"
 298                do_merge=t
 299                ;;
 300        --no-stat)
 301                diffstat=
 302                ;;
 303        --stat)
 304                diffstat=t
 305                ;;
 306        --autostash)
 307                autostash=true
 308                ;;
 309        --no-autostash)
 310                autostash=false
 311                ;;
 312        --verbose)
 313                verbose=t
 314                diffstat=t
 315                GIT_QUIET=
 316                ;;
 317        --quiet)
 318                GIT_QUIET=t
 319                git_am_opt="$git_am_opt -q"
 320                verbose=
 321                diffstat=
 322                ;;
 323        --whitespace=*)
 324                git_am_opt="$git_am_opt --whitespace=${1#--whitespace=}"
 325                case "${1#--whitespace=}" in
 326                fix|strip)
 327                        force_rebase=t
 328                        ;;
 329                esac
 330                ;;
 331        --ignore-whitespace)
 332                git_am_opt="$git_am_opt $1"
 333                ;;
 334        --committer-date-is-author-date|--ignore-date|--signoff|--no-signoff)
 335                git_am_opt="$git_am_opt $1"
 336                force_rebase=t
 337                ;;
 338        -C*)
 339                git_am_opt="$git_am_opt $1"
 340                ;;
 341        --root)
 342                rebase_root=t
 343                ;;
 344        --force-rebase|--no-ff)
 345                force_rebase=t
 346                ;;
 347        --rerere-autoupdate|--no-rerere-autoupdate)
 348                allow_rerere_autoupdate="$1"
 349                ;;
 350        --gpg-sign)
 351                gpg_sign_opt=-S
 352                ;;
 353        --gpg-sign=*)
 354                gpg_sign_opt="-S${1#--gpg-sign=}"
 355                ;;
 356        --)
 357                shift
 358                break
 359                ;;
 360        *)
 361                usage
 362                ;;
 363        esac
 364        shift
 365done
 366test $# -gt 2 && usage
 367
 368if test -n "$action"
 369then
 370        test -z "$in_progress" && die "$(gettext "No rebase in progress?")"
 371        # Only interactive rebase uses detailed reflog messages
 372        if test "$type" = interactive && test "$GIT_REFLOG_ACTION" = rebase
 373        then
 374                GIT_REFLOG_ACTION="rebase -i ($action)"
 375                export GIT_REFLOG_ACTION
 376        fi
 377fi
 378
 379if test "$action" = "edit-todo" && test "$type" != "interactive"
 380then
 381        die "$(gettext "The --edit-todo action can only be used during interactive rebase.")"
 382fi
 383
 384case "$action" in
 385continue)
 386        # Sanity check
 387        git rev-parse --verify HEAD >/dev/null ||
 388                die "$(gettext "Cannot read HEAD")"
 389        git update-index --ignore-submodules --refresh &&
 390        git diff-files --quiet --ignore-submodules || {
 391                echo "$(gettext "You must edit all merge conflicts and then
 392mark them as resolved using git add")"
 393                exit 1
 394        }
 395        read_basic_state
 396        run_specific_rebase
 397        ;;
 398skip)
 399        output git reset --hard HEAD || exit $?
 400        read_basic_state
 401        run_specific_rebase
 402        ;;
 403abort)
 404        git rerere clear
 405        read_basic_state
 406        case "$head_name" in
 407        refs/*)
 408                git symbolic-ref -m "rebase: aborting" HEAD $head_name ||
 409                die "$(eval_gettext "Could not move back to \$head_name")"
 410                ;;
 411        esac
 412        output git reset --hard $orig_head
 413        finish_rebase
 414        exit
 415        ;;
 416quit)
 417        exec rm -rf "$state_dir"
 418        ;;
 419edit-todo)
 420        run_specific_rebase
 421        ;;
 422show-current-patch)
 423        run_specific_rebase
 424        die "BUG: run_specific_rebase is not supposed to return here"
 425        ;;
 426esac
 427
 428# Make sure no rebase is in progress
 429if test -n "$in_progress"
 430then
 431        state_dir_base=${state_dir##*/}
 432        cmd_live_rebase="git rebase (--continue | --abort | --skip)"
 433        cmd_clear_stale_rebase="rm -fr \"$state_dir\""
 434        die "
 435$(eval_gettext 'It seems that there is already a $state_dir_base directory, and
 436I wonder if you are in the middle of another rebase.  If that is the
 437case, please try
 438        $cmd_live_rebase
 439If that is not the case, please
 440        $cmd_clear_stale_rebase
 441and run me again.  I am stopping in case you still have something
 442valuable there.')"
 443fi
 444
 445if test -n "$rebase_root" && test -z "$onto"
 446then
 447        test -z "$interactive_rebase" && interactive_rebase=implied
 448fi
 449
 450if test -n "$interactive_rebase"
 451then
 452        type=interactive
 453        state_dir="$merge_dir"
 454elif test -n "$do_merge"
 455then
 456        type=merge
 457        state_dir="$merge_dir"
 458else
 459        type=am
 460        state_dir="$apply_dir"
 461fi
 462
 463if test -t 2 && test -z "$GIT_QUIET"
 464then
 465        git_format_patch_opt="$git_format_patch_opt --progress"
 466fi
 467
 468if test -z "$rebase_root"
 469then
 470        case "$#" in
 471        0)
 472                if ! upstream_name=$(git rev-parse --symbolic-full-name \
 473                        --verify -q @{upstream} 2>/dev/null)
 474                then
 475                        . git-parse-remote
 476                        error_on_missing_default_upstream "rebase" "rebase" \
 477                                "against" "git rebase $(gettext '<branch>')"
 478                fi
 479
 480                test "$fork_point" = auto && fork_point=t
 481                ;;
 482        *)      upstream_name="$1"
 483                if test "$upstream_name" = "-"
 484                then
 485                        upstream_name="@{-1}"
 486                fi
 487                shift
 488                ;;
 489        esac
 490        upstream=$(peel_committish "${upstream_name}") ||
 491        die "$(eval_gettext "invalid upstream '\$upstream_name'")"
 492        upstream_arg="$upstream_name"
 493else
 494        if test -z "$onto"
 495        then
 496                empty_tree=$(git hash-object -t tree /dev/null)
 497                onto=$(git commit-tree $empty_tree </dev/null)
 498                squash_onto="$onto"
 499        fi
 500        unset upstream_name
 501        unset upstream
 502        test $# -gt 1 && usage
 503        upstream_arg=--root
 504fi
 505
 506# Make sure the branch to rebase onto is valid.
 507onto_name=${onto-"$upstream_name"}
 508case "$onto_name" in
 509*...*)
 510        if      left=${onto_name%...*} right=${onto_name#*...} &&
 511                onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
 512        then
 513                case "$onto" in
 514                ?*"$LF"?*)
 515                        die "$(eval_gettext "\$onto_name: there are more than one merge bases")"
 516                        ;;
 517                '')
 518                        die "$(eval_gettext "\$onto_name: there is no merge base")"
 519                        ;;
 520                esac
 521        else
 522                die "$(eval_gettext "\$onto_name: there is no merge base")"
 523        fi
 524        ;;
 525*)
 526        onto=$(peel_committish "$onto_name") ||
 527        die "$(eval_gettext "Does not point to a valid commit: \$onto_name")"
 528        ;;
 529esac
 530
 531# If the branch to rebase is given, that is the branch we will rebase
 532# $branch_name -- branch/commit being rebased, or HEAD (already detached)
 533# $orig_head -- commit object name of tip of the branch before rebasing
 534# $head_name -- refs/heads/<that-branch> or "detached HEAD"
 535switch_to=
 536case "$#" in
 5371)
 538        # Is it "rebase other $branchname" or "rebase other $commit"?
 539        branch_name="$1"
 540        switch_to="$1"
 541
 542        # Is it a local branch?
 543        if git show-ref --verify --quiet -- "refs/heads/$branch_name" &&
 544           orig_head=$(git rev-parse -q --verify "refs/heads/$branch_name")
 545        then
 546                head_name="refs/heads/$branch_name"
 547        # If not is it a valid ref (branch or commit)?
 548        elif orig_head=$(git rev-parse -q --verify "$branch_name")
 549        then
 550                head_name="detached HEAD"
 551
 552        else
 553                die "$(eval_gettext "fatal: no such branch/commit '\$branch_name'")"
 554        fi
 555        ;;
 5560)
 557        # Do not need to switch branches, we are already on it.
 558        if branch_name=$(git symbolic-ref -q HEAD)
 559        then
 560                head_name=$branch_name
 561                branch_name=$(expr "z$branch_name" : 'zrefs/heads/\(.*\)')
 562        else
 563                head_name="detached HEAD"
 564                branch_name=HEAD
 565        fi
 566        orig_head=$(git rev-parse --verify HEAD) || exit
 567        ;;
 568*)
 569        die "BUG: unexpected number of arguments left to parse"
 570        ;;
 571esac
 572
 573if test "$fork_point" = t
 574then
 575        new_upstream=$(git merge-base --fork-point "$upstream_name" \
 576                        "${switch_to:-HEAD}")
 577        if test -n "$new_upstream"
 578        then
 579                restrict_revision=$new_upstream
 580        fi
 581fi
 582
 583if test "$autostash" = true && ! (require_clean_work_tree) 2>/dev/null
 584then
 585        stash_sha1=$(git stash create "autostash") ||
 586        die "$(gettext 'Cannot autostash')"
 587
 588        mkdir -p "$state_dir" &&
 589        echo $stash_sha1 >"$state_dir/autostash" &&
 590        stash_abbrev=$(git rev-parse --short $stash_sha1) &&
 591        echo "$(eval_gettext 'Created autostash: $stash_abbrev')" &&
 592        git reset --hard
 593fi
 594
 595require_clean_work_tree "rebase" "$(gettext "Please commit or stash them.")"
 596
 597# Now we are rebasing commits $upstream..$orig_head (or with --root,
 598# everything leading up to $orig_head) on top of $onto
 599
 600# Check if we are already based on $onto with linear history,
 601# but this should be done only when upstream and onto are the same
 602# and if this is not an interactive rebase.
 603mb=$(git merge-base "$onto" "$orig_head")
 604if test "$type" != interactive && test "$upstream" = "$onto" &&
 605        test "$mb" = "$onto" && test -z "$restrict_revision" &&
 606        # linear history?
 607        ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
 608then
 609        if test -z "$force_rebase"
 610        then
 611                # Lazily switch to the target branch if needed...
 612                test -z "$switch_to" ||
 613                GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to" \
 614                        git checkout -q "$switch_to" --
 615                if test "$branch_name" = "HEAD" &&
 616                         ! git symbolic-ref -q HEAD
 617                then
 618                        say "$(eval_gettext "HEAD is up to date.")"
 619                else
 620                        say "$(eval_gettext "Current branch \$branch_name is up to date.")"
 621                fi
 622                finish_rebase
 623                exit 0
 624        else
 625                if test "$branch_name" = "HEAD" &&
 626                         ! git symbolic-ref -q HEAD
 627                then
 628                        say "$(eval_gettext "HEAD is up to date, rebase forced.")"
 629                else
 630                        say "$(eval_gettext "Current branch \$branch_name is up to date, rebase forced.")"
 631                fi
 632        fi
 633fi
 634
 635# If a hook exists, give it a chance to interrupt
 636run_pre_rebase_hook "$upstream_arg" "$@"
 637
 638if test -n "$diffstat"
 639then
 640        if test -n "$verbose"
 641        then
 642                echo "$(eval_gettext "Changes from \$mb to \$onto:")"
 643        fi
 644        # We want color (if set), but no pager
 645        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 646fi
 647
 648test "$type" = interactive && run_specific_rebase
 649
 650# Detach HEAD and reset the tree
 651say "$(gettext "First, rewinding head to replay your work on top of it...")"
 652
 653GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name" \
 654        git checkout -q "$onto^0" || die "could not detach HEAD"
 655git update-ref ORIG_HEAD $orig_head
 656
 657# If the $onto is a proper descendant of the tip of the branch, then
 658# we just fast-forwarded.
 659if test "$mb" = "$orig_head"
 660then
 661        say "$(eval_gettext "Fast-forwarded \$branch_name to \$onto_name.")"
 662        move_to_original_branch
 663        finish_rebase
 664        exit 0
 665fi
 666
 667if test -n "$rebase_root"
 668then
 669        revisions="$onto..$orig_head"
 670else
 671        revisions="${restrict_revision-$upstream}..$orig_head"
 672fi
 673
 674run_specific_rebase